/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: Export.java,v 1.5 2002/12/05 21:29:34 kboo Exp $
 */

package com.bs.xdbms.cli;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

import java.io.*;

import org.w3c.dom.*;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.Serializer;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.SerializerFactory;

class Export extends AbstractCommand {
  private String xml;

  public Export(Collection collection, String arg) {
    currentCollection = collection;
    xml = arg;
  }

  public void execute() throws Exception {
    System.out.println("Retrieving " + xml + " from the collection.");
    Collection collection = null;
    try {
      collection = getCurrentCollection();

      String id = xml;

      XMLResource resource = (XMLResource) collection.getResource(xml);
      Document doc = (Document) resource.getContentAsDOM();
      // TBD - Test if doc is null.

      // Print out
      PrintWriter writer = 
        new PrintWriter
          (new OutputStreamWriter(new FileOutputStream(xml),"UTF8"),true);
      OutputFormat format = new OutputFormat(doc, "UTF-8", true);
      XMLSerializer ser = new XMLSerializer(writer, format);
      ser.asDOMSerializer();
      ser.serialize(doc);
      writer.close();
    } catch (XMLDBException e) {
      e.printStackTrace();
      System.err.println("XML:DB Exception occured " + e.errorCode);
    } catch (IOException e2) {
      e2.printStackTrace();
    } catch (Exception e3) {
      e3.printStackTrace();
    }
  }
}
