/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: Import.java,v 1.5 2002/12/05 21:29:34 kboo Exp $
 */

package com.bs.xdbms.cli;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

import java.io.*;

import org.w3c.dom.*;

import org.xml.sax.SAXException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.*;

class Import extends AbstractCommand {
  private String xml;

  public Import(Collection collection, String arg) {
    currentCollection = collection;
    xml = arg;
  }

  public void execute() throws Exception {
    System.out.println("Importing " + xml + " to the collection.");
    Collection col = null;
    try {
      col = getCurrentCollection();
      Document document = getDocument(xml);
      XMLResource resource = (XMLResource)col.createResource
        (xml, XMLResource.RESOURCE_TYPE);

      resource.setContentAsDOM(document);
      col.storeResource(resource);       
    } catch (XMLDBException e) {
      e.printStackTrace();
      System.err.println("XML:DB Exception occured " + e.errorCode);
    } catch (Exception e2) {
      e2.printStackTrace();
    }
  }
}
