/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: Update.java,v 1.4 2002/12/05 21:29:34 kboo Exp $
 */
package com.bs.xdbms.cli;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

import java.io.*;

import org.w3c.dom.*;

import org.xml.sax.SAXException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.*;

class Update extends AbstractCommand {
  private String xml;

  public Update(Collection collection, String arg) {
    currentCollection = collection;
    xml = arg;
  }

  public void execute() throws Exception {
    System.out.println("Updating " + xml + " in the collection.");
    Collection col = null;
    try {
      // Remove existing document first.
      col = getCurrentCollection();
      col.removeResource(col.getResource(xml));

      // Recreate the document in the database      
      Document document = getDocument(xml);
      XMLResource resource = (XMLResource)col.createResource
        (xml, XMLResource.RESOURCE_TYPE);

      resource.setContentAsDOM(document);
      col.storeResource(resource); 
    } catch (XMLDBException e) {
      e.printStackTrace();
      System.err.println("XML:DB Exception occured " + e.errorCode);
    } catch (Exception e2) {
      e2.printStackTrace();
    }
  }
}
