/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: XAttribute.java,v 1.5 2002/10/20 03:01:35 kboo Exp $
 */
package com.bs.xdbms.datamodel;

public class XAttribute extends XNode {

  private XSQName xsqname; // expanded-QName
    
  private XAttribute() {
  }

  public XAttribute(String nsURI, String name, String value) {
    nodeKind = "attribute";
    xsqname = new XSQName(nsURI,name);
    stringValue = value;
  }

  public String getNamespaceURI() {
    return xsqname.getNamespaceURI();
  }

  public String getLocalName() {
    return xsqname.getLocalName();
  }

  public String getQName() {
    if (getPrefix() != null)
      return getPrefix() + ":" + getLocalName();
    else
      return getLocalName();
  }

  public String getPrefix() {
    XNode parent = getParent();
    if (parent != null && parent.getNodeKind().equals("element"))
      return ((XElement)parent).getPrefix();
    else
      return null;
  }

}
