/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: XDocument.java,v 1.8 2002/10/20 03:01:35 kboo Exp $
 */
package com.bs.xdbms.datamodel;

import java.util.Vector;

public class XDocument extends XNode {
    
  public XDocument() {
    nodeKind = "document";
    children = new Vector();
  }

  public void setBaseURI(String anyURI) {
    baseURI = anyURI;
  }

  public void appendChild(XNode node) throws XModelException {
    String nk = node.getNodeKind();
    if (nk.equals("element")
        || nk.equals("processing-instruction")
        || nk.equals("comment")) {
      children.addElement(node);
      node.setParent(this);
    }
    else
      throw new XModelException("Node kind: " + nk + " cannot be added to the Document node.");
  }

  public XElement createElement(String localName) {
    XElement el = createElement(null,localName);
    return el;
  }

  public XElement createElement(String nsURI, String localName) {
    XElement el = new XElement(nsURI,localName);
    //children.addElement(el);
    //el.setParent(this);
    return el;
  }

  public XText createText(String value) {
    XText text = new XText(value);
    return text;
  }

  public XAttribute createAttribute(String localName, String value) {
    XAttribute attr = createAttribute(null,localName,value);
    return attr;
  }

  public XAttribute createAttribute(String nsURI, String localName, String value) {
    XAttribute attr = new XAttribute(nsURI,localName,value);
    return attr;
  }

  public XComment createComment(String value) {
    XComment comment = new XComment(value);
    //children.addElement(comment);
    //comment.setParent(this);
    return comment;
  }

  public XProcessingInstruction createProcessingInstruction
      (String qname, String value) {
    XProcessingInstruction pi = new XProcessingInstruction(qname,value);
    //children.addElement(pi);
    //pi.setParent(this);
    return pi;
  }
}
