/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: XNode.java,v 1.6 2002/10/20 03:01:35 kboo Exp $
 */
package com.bs.xdbms.datamodel;

import java.util.Vector;
import com.bs.xdbms.persistence.PersistenceObject;

public abstract class XNode extends PersistenceObject {
  protected String nodeKind;
  protected String name;
  protected String baseURI;
  protected String stringValue;
  protected Vector typedValue;
  protected XNode parent;
  protected Vector children; // Vector of XNodes
  protected Vector attributes; // Vector of XAttributes
  protected Vector namespaces; // Vector of XNamespaces
  protected XSchemaComponent declaration;
  protected XSchemaComponent type;
  protected String uniqueID;
    
  public String getNodeKind() {
    return nodeKind;
  }
    
  public String getName() {
    return name;
  }
    
  public String getBaseURI() {
    return baseURI;
  }

  public String getStringValue() {
    return stringValue;
  }
    
  public void setStringValue(String value) {
    stringValue = value;
  }

  public Vector getTypedValue() {
    return typedValue;
  }
    
  public XNode getParent() {
    return parent;
  }

  public void setParent(XNode node) {
    parent = node;
  }
    
  public Vector getChildren() {
    return children;
  }

  public Vector getAttributes() {
    return attributes;
  }
    
  public Vector getNamespaces() {
    return namespaces;
  }
    
  public XSchemaComponent getDeclaration() {
    return declaration;
  }
    
  public XSchemaComponent getType() {
    return type;
  }
    
  public String getUniqueID() {
    return uniqueID;
  }
}
