/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: ModelToDOM.java,v 1.6 2002/10/20 03:01:35 kboo Exp $
 */

package com.bs.xdbms.persistence;

import java.util.Vector;
import com.bs.xdbms.datamodel.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;

//
// Usage:
//  XDocument xdoc = ...
//  ModelToDOM m2d = new ModelToDOM();
//  Document doc = m2d.convert(xdoc);
//
public class ModelToDOM {

  public Document convert(XDocument xdoc) throws DOMException {
    /*
     * TBD - Investigate later.
     * This block does not work. It breaks later when I call
     * doc.createElementNS() for some reason.
     *
    DOMImplementation di = DOMImplementationImpl.getDOMImplementation();

    DocumentType dt = null;
    dt = di.createDocumentType(qname,pid,sid);

    String nsURI = xdoc.getBaseURI(); // TBD - Use namespace URI
    String qname = xdoc.getBaseURI(); // TBD - What is this?
    Document doc = di.createDocument(nsURI,"qname",dt);
    */

    Document doc = new DocumentImpl(null);
    Vector children = xdoc.getChildren();
    XNode xchild = null;
    Element el = null;
    String nodeKind;
    //System.out.println("children size must be 1: " + children.size());
    // TBD - Raise exception if the number is not 1.

    for (int i=0; i<children.size(); i++) {
      xchild = (XNode)children.elementAt(i);
      nodeKind = xchild.getNodeKind();
      if (nodeKind.equals("element")) {
        el = convert((XElement)xchild,doc);
        doc.appendChild(el);
      } else if (nodeKind.equals("comment")) { // cannot happen
        // TBD
      } else if (nodeKind.equals("processing-instruction")) { // cannot happen
        // TBD
      }
    } // end for

    return doc;
  }

  private Element convert(XElement xel, Document doc) {
    Element el = doc.createElementNS
                        (xel.getNamespaceURI(),
                         xel.getLocalName());

    // TBD - setPrefix if xel has a xnamespace.

    // map attributes
    Vector attributes = xel.getAttributes();
    XAttribute xattr;
    for (int i=0; i<attributes.size(); i++) {
      xattr = (XAttribute)attributes.elementAt(i);
      el.setAttributeNS
          (xattr.getNamespaceURI(),
           xattr.getLocalName(),
           xattr.getStringValue());
    }

    // map children
    Vector children = xel.getChildren();
    XNode xchild;
    Node child;
    String nodeKind;
    for (int i=0; i<children.size(); i++) {
      xchild = (XNode)children.elementAt(i);
      nodeKind = xchild.getNodeKind();
      if (nodeKind.equals("element")) {
        child = convert((XElement)xchild,doc);
        el.appendChild(child);
      } else if (nodeKind.equals("text")) {
        child = convert((XText)xchild,doc);
        el.appendChild(child);
      } else if (nodeKind.equals("comment")) {
        // TBD
      } else if (nodeKind.equals("processing-instruction")) {
        // TBD
      }
    } // end for
    return el;
  } // end convert()

  private Text convert(XText xtext, Document doc) {
    Text text = doc.createTextNode(xtext.getStringValue());
    return text;
  }

} // class ModelToDOM
