/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: ConfigurableImpl.java,v 1.2 2002/10/20 03:01:35 kboo Exp $
 */

package com.bs.xdbms.xmldb.base;

import java.util.Hashtable;

import org.xmldb.api.base.Configurable;
import org.xmldb.api.base.XMLDBException;

/**
 * Provides the ability to configure properties about an object.
 */
public class ConfigurableImpl implements Configurable {

  private Hashtable properties = new Hashtable();

   /**
    * Returns the value of the property identified by <code>name</code>.
    *
    * @param name the name of the property to retrieve.
    * @return the property value or null if no property exists.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
  public String getProperty(String name) throws XMLDBException {
    return (String)properties.get(name);
  }

   /**
    * Sets the property <code>name</code> to have the value provided in 
    * <code>value</code>.
    *
    * @param name the name of the property to set.
    * @param value the value to set for the property.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
  public void setProperty(String name, String value) throws XMLDBException {
    properties.put(name,value);
  }
}