/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: ResourceIteratorImpl.java,v 1.2 2002/10/20 03:01:35 kboo Exp $
 */

package com.bs.xdbms.xmldb.base;

import java.util.Vector;

import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.XMLDBException;

/**
 * ResourceIterator is used to iterate over a set of resources.
 */
final public class ResourceIteratorImpl implements ResourceIterator {
   /**
    * Returns true as long as there are still more resources to be iterated.
    *
    * @return true if there are more resources to iterate, false otherwise.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public boolean hasMoreResources() throws XMLDBException {
     // TBD
     return false;
   }

   /**
    * Returns the next <code>Resource</code> instance in the iterator.
    *
    * @return the next <code>Resource</code> instance in the iterator.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    *  <code>ErrorCodes.NO_SUCH_RESOURCE</code> if the resource iterator is 
    *  empty or all resources have already been retrieved.
    */
   public Resource nextResource() throws XMLDBException {
     // TBD 
     return null;
   }
}

