/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: ResourceSetImpl.java,v 1.2 2002/10/20 03:01:35 kboo Exp $
 */

package com.bs.xdbms.xmldb.base;

import java.util.Vector;

import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceSet;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.XMLDBException;

 /**
 * ResourceSet is a container for a set of resources. Generally a 
 * <code>ResourceSet</code> is obtained as the result of a query.
 */
final public class ResourceSetImpl implements ResourceSet {
   /**
    * Returns the <code>Resource</code> instance stored at the index specified 
    * by index.
    * <p />
    * If the underlying implementation uses a paging or streaming optimization 
    * for retrieving Resource instances. Calling this method MAY result in a 
    * block until the requested Resource has been downloaded.
    *
    * @param index the index of the resource to retrieve.
    * @return The <code>Resource</code> instance
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    * <code>ErrorCodes.NO_SUCH_RESOURCE if the index is out of range for the
    * set.
    */
   public Resource getResource(long index) throws XMLDBException {
     // TBD
     return null;
   }

   /**
    * Adds a <code>Resource</code> instance to the set.
    *
    * @param res The <code>Resource</code> to add to the set.
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public void addResource(Resource res) throws XMLDBException {
     // TBD
   }

   /**
    * Removes the Resource located at <code>index</code> from the set.
    *
    * @param index  The index of the <code>Resource</code> instance to remove.
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public void removeResource(long index) throws XMLDBException {
     // TBD
   }

   /**
    * Returns an iterator over all <code>Resource</code> instances stored in the set.
    *
    * @return a <code>ResourceIterator</code> over all <code>Resource</code> 
    *   instances in the set.
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public ResourceIterator getIterator() throws XMLDBException {
     // TBD
     return null;
   }

   /**
    * Returns a Resource containing an XML representation of all resources 
    * stored in the set. <p />
    * TODO: Specify the schema used for this
    *
    * @return A <code>Resource</code> instance containing an XML representation 
    *   of all set members.
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public Resource getMembersAsResource() throws XMLDBException {
     // TBD
     return null;
   }

   /**
    * Returns the number of resources contained in the set.
    * <p />
    * If the underlying implementation uses a paging or streaming optimization 
    * for retrieving <code>Resource</code> instances. Calling this method MAY 
    * force the downloading of all set members before the size can be determined.
    *
    * @return The number of <code>Resource</code> instances in the set.
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public long getSize() throws XMLDBException {
     // TBD
     return 0;
   }

   /**
    * Removes all <code>Resource</code> instances from the set.
    *
    * @exception XMLDBException with expected error codes.<br />
    * <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    * specific errors that occur.<br />
    */
   public void clear() throws XMLDBException  {
     // TBD
   }
}