/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: BinaryResourceImpl.java,v 1.4 2002/12/13 22:37:48 kboo Exp $
 */
package com.bs.xdbms.xmldb.modules;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.BinaryResource;

import com.bs.xdbms.xmldb.base.ResourceImpl;

/**
 * Resource for encapsulation of binary data that is stored in the data base.
 * Support for BinaryResources is optional.<p />
 *
 * The standard <code>getContent</code> method returns a <code>byte[]
 * </code> and the standard setContent expects an <code>byte[]</code>.<p /> 
 */
final public class BinaryResourceImpl 
    extends ResourceImpl 
    implements BinaryResource {

  public BinaryResourceImpl(String resourceId, Collection parent) {
    id = resourceId; // id is null for an anonymous resource
    type = "BinaryResource";
    parentCollection = parent;
  }
}

