/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: XPathQueryServiceImpl.java,v 1.2 2002/10/20 03:01:35 kboo Exp $
 */
package com.bs.xdbms.xmldb.modules;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.XPathQueryService;

import com.bs.xdbms.xmldb.base.ServiceImpl;

/**
 * XPathQueryService is a <code>Service</code> that enables the execution of
 * XPath queries within the context of a <code>Collection</code> or against a 
 * single XML <code>Resource</code> stored in the <code>Collection</code>.
 */
final public class XPathQueryServiceImpl 
    extends ServiceImpl 
    implements XPathQueryService {
   
   /**
    * Sets a namespace mapping in the internal namespace map used to evaluate
    * queries. If <code>prefix</code> is null or empty the default namespace is
    * associated with the provided URI. A null or empty <code>uri</code> results
    * in an exception being thrown.
    *
    * @param prefix The prefix to set in the map. If 
    *  <code>prefix</code> is empty or null the
    *  default namespace will be associated with the provided URI.
    * @param uri The URI for the namespace to be associated with prefix.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    *  TODO: probably need some special error here.
    */
   public void setNamespace( String prefix, String uri ) throws XMLDBException {
     // TBD
   }

   /**   
    * Returns the URI string associated with <code>prefix</code> from
    * the internal namespace map. If <code>prefix</code> is null or empty the
    * URI for the default namespace will be returned. If a mapping for the 
    * <code>prefix</code> can not be found null is returned.
    *
    * @param prefix The prefix to retrieve from the namespace map. 
    * @return The URI associated with <code>prefix</code>
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public String getNamespace( String prefix ) throws XMLDBException {
     // TBD
     return null;
   }
   
   /**   
    * Removes the namespace mapping associated with <code>prefix</code> from
    * the internal namespace map. If <code>prefix</code> is null or empty the
    * mapping for the default namespace will be removed.
    *
    * @param prefix The prefix to remove from the namespace map. If 
    *  <code>prefix</code> is null or empty the mapping for the default
    *  namespace will be removed.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public void removeNamespace( String prefix ) throws XMLDBException {
     // TBD
   }

   /**
    * Removes all namespace mappings stored in the internal namespace map.
    *
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public void clearNamespaces() throws XMLDBException {
     // TBD
   }
   
   /**
    * Run an XPath query against the <code>Collection</code>. The XPath will be
    * applied to all XML resources stored in the <code>Collection</code>. 
    * The result is a 
    * <code>ResourceSet</code> containing the results of the query. Any
    * namespaces used in the <code>query</code> string will be evaluated using
    * the mappings setup using <code>setNamespace</code>.
    *
    * @param query The XPath query string to use.
    * @return A <code>ResourceSet</code> containing the results of the query.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public ResourceSet query( String query ) throws XMLDBException {
     // TBD
     return null;
   }

   /**
    * Run an XPath query against an XML resource stored in the 
    * <code>Collection</code> associated with this service. The result is a 
    * <code>ResourceSet</code> containing the results of the query. Any
    * namespaces used in the <code>query</code> string will be evaluated using
    * the mappings setup using <code>setNamespace</code>.
    *
    * @param query The XPath query string to use.
    * @param id The id of the document to run the query against.
    * @return A <code>ResourceSet</code> containing the results of the query.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */   
   public ResourceSet queryResource( String id, String query ) 
     throws XMLDBException {
     // TBD
     return null;
   }
}

