/*
 * (C) Copyright Bora Software Inc. 2002, 2003 - All Rights Reserved.
 *
 * $Id: XUpdateQueryServiceImpl.java,v 1.2 2002/10/20 03:01:35 kboo Exp $
 */
package com.bs.xdbms.xmldb.modules;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.XUpdateQueryService;

import com.bs.xdbms.xmldb.base.ServiceImpl;

/**
 * XUpdateQueryService is a <code>Service</code> that enables the execution of
 * XUpdate queries within the context of a <code>Collection</code> or against a 
 * single document stored in a collection.
 */
public class XUpdateQueryServiceImpl 
    extends ServiceImpl 
    implements XUpdateQueryService {

   /**
    * Runs a set of XUpdate operations against the collection. All selected 
    * documents are to be updated and stored back to the repository.
    *
    * @param commands The XUpdate commands to use.
    * @return the number of modified nodes.    
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
  public long update(String commands) throws XMLDBException {
    // TBD
    return 0;
  }
   
   /**
    * Runs a set of XUpdate operations against a resource stored in a 
    * collection. The resource will be updated in place in the collection.
    *
    * @param commands The XUpdate commands to use.    
    * @return the number of modified nodes.
    * @exception XMLDBException with expected error codes.<br />
    *  <code>ErrorCodes.VENDOR_ERROR</code> for any vendor
    *  specific errors that occur.<br />
    */
   public long updateResource(String id, String commands) 
     throws XMLDBException {
     // TBD
     return 0;
   }
}

